<?php

namespace JFalke\Controllers;

use JFalke\Models\Brand;
use PDO;
use Psr\Http\Message\RequestInterface;
use Psr\Http\Message\ResponseInterface;
use Slim\Views\Twig;

class BrandsListingController
{
    private PDO $pdo;
    private Twig $twig;

    public function __construct(PDO $pdo, Twig $twig)
    {
        $this->pdo = $pdo;
        $this->twig = $twig;
    }

    public function handle (RequestInterface $request, ResponseInterface $response) {
            $listBrands = $this->getAllBrand();

            return $this->twig->render($response, 'accueil.tpl', [
                "listBrands" => $listBrands
        ]);
    }

    public function getAllBrand(){
        $stmt = $this->pdo->prepare('SELECT * FROM brands ORDER BY name ASC');
        $stmt->execute();
        $brands = $stmt->fetchAll();

        $listBrands = array();
        foreach ($brands as $brand){
            $tmpBrand = new Brand(
                $brand["id"],
                $brand["name"]
            );

            array_push($listBrands, $tmpBrand);
        }

        return $listBrands;
    }
}
