<?php


namespace JFalke\Features\SearchBrands;

use JFalke\Exceptions\CouldNotGetBrandsException;
use JFalke\Exceptions\MissingInputParametersException;
use Psr\Http\Message\RequestInterface;
use Psr\Http\Message\ResponseInterface;

class SearchBrandsController
{
    private SearchBrandsService $service;

    public function __construct(SearchBrandsService $service)
    {
        $this->service = $service;
    }

    public function __invoke(RequestInterface $request, ResponseInterface $response): ResponseInterface {

        try {
            $body = $_POST["searchValue"];
            $body = json_decode($body);

            $businessRequest = SearchBrandsRequest::from($body);
            $businessResponse = $this->service->handle($businessRequest);

            return $businessResponse;

        } catch (MissingInputParametersException $exception) {
            return $response->withStatus(400, 'Missing input parameters');
        } catch (CouldNotGetBrandsException $exception) {
            return $response->withStatus(404, $exception->getMessage());
        }
    }
}