<?php


namespace JFalke\Features\SearchBrands;

use JFalke\Exceptions\MissingInputParametersException;
use stdClass;

class SearchBrandsRequest
{
    private string $brandName;

    public function __construct(string $brandName)
    {
        $this->brandName = $brandName;
    }

    /**
     * @return string
     */
    public function getBrandName(): string
    {
        return $this->brandName;
    }



    public static function from(stdClass $json): self
    {
        if (empty($json->brandName)) {
            throw new MissingInputParametersException();
        }

        return new self($json->brandName);
    }

}