<?php


namespace JFalke\Features\SearchBrands;

use JFalke\Exceptions\CouldNotGetBrandsException;
use JFalke\Repositories\BrandRepository;

class SearchBrandsService
{
    private BrandRepository $repository;

    public function __construct(BrandRepository $repository)
    {
        $this->repository = $repository;
    }

    public function handle(SearchBrandsRequest $request): SearchBrandsResponse
    {
        if($this->repository->isToutes($request)){
            $brands = $this->repository->getAllBrands();
        } else {
            $brands = $this->repository->getBrands($request);
        }

        if ($brands === null) {
            throw new CouldNotGetBrandsException();
        }

        return new SearchBrandsResponse($brands);
    }
}