<?php


namespace JFalke\Repositories;

use JFalke\Features\SearchBrands\SearchBrandsRequest;
use JFalke\Models\Brand;
use PDO;

class PDOBrandRepository implements BrandRepository
{
    private PDO $pdo;

    public function getAllBrands() : ?array
    {
        $stmt = $this->pdo->prepare(
            "SELECT * FROM brands ORDER BY name ASC"
        );

        $stmt->execute();

        if($stmt){
            return $stmt->fetchAll();
        }

        return null;
    }

    public function getBrands(SearchBrandsRequest $request): ?array
    {
        $searchVal = strtoupper($request->getBrandName());

        $stmt = $this->pdo->prepare(
            "SELECT * FROM brands
                            WHERE UPPER(name) LIKE '%" . $searchVal . "%'
                            ORDER BY name ASC"
        );

        $stmt->execute();

        if($stmt){
            return $stmt->fetchAll();
        }

        return null;
    }

    public function isToutes(SearchBrandsRequest $request): bool
    {
        $name = strtolower($request->getBrandName());
        if($name == "toutes"){
            return true;
        }
        return false;
    }
}