<?php

namespace JFalke\Features\SearchBrands;

use JFalke\Exceptions\MissingInputParametersException;
use JFalke\Features\SearchBrands\SearchBrandsRequest;
use PHPUnit\Framework\TestCase;
use stdClass;

class SearchBrandsRequestTest extends TestCase
{
    public function testShouldThrowExceptionWhenParamsNotFilled(): void
    {
        $this->expectException(MissingInputParametersException::class);
        $stdClass = new stdClass();
        SearchBrandsRequest::from($stdClass);
    }

    public function testShouldCreateRequestWithProperties():void
    {
        $stdClass = new stdClass();
        $stdClass->brandName = 'AEON MOTORCYCLES';
        $request = SearchBrandsRequest::from($stdClass);

        $this->assertSame('AEON MOTORCYCLES', $request->getBrandName());
    }
}