let path = require('path');
let webpack = require('webpack');

module.exports = {
    entry: path.resolve( 'javascripts', 'index.js'),
    mode: 'production',
    output: {
        path: path.resolve('public', 'assets'),
        filename: 'compress.js'
    },
    plugins: [
        new webpack.ProvidePlugin({
            $: "jquery",
            jQuery: "jquery",
            "window.jQuery": "jquery"
        })
    ],
    module: {
        rules: [
            {
                test: /.js$/,
                exclude: /node_modules/,
                loader: "babel-loader"
            },
            {
                test: /.s[ac]ss$/i,
                use: [
                    'style-loader',
                    'css-loader',
                    {
                        loader: 'sass-loader',
                        options: {
                            sourceMap: true,
                            sassOptions: {
                                outputStyle: 'compressed',
                            },
                        },
                    },
                ],
            },
        ],
    },
    watch: process.env.PROJECT_ENV === 'dev',
    watchOptions: {
        aggregateTimeout: 200,
        ignored: /node_modules/
    },
    optimization: {
        minimize: true
    }
};